package {
	import com.greensock.easing.Cubic;
	import flash.display.BlendMode;
	import flash.display.Sprite;
	import com.greensock.TweenLite;
	import flash.geom.Point;
	
	/**
	 * ...
	 * @author netgrind
	 */
	public class Birth extends Level {
		public var oldPoint:Point = new Point();
		public var oldMouse:Point = new Point();
		
		public var tunnel:Vector.<Sprite> = new Vector.<Sprite>;
				
		public function Birth() {
			
			for (var i:int = 0; i < 20; i++) {
				var s:Sprite = UtilsArt.makeRectangle(1200, 1000, ( i * 10 << 16 |  i * 10 << 8 |  i * 10));
				var c:Sprite = UtilsArt.makeCircle(250);
				s.addChild(c);
				c.x = 600;
				c.y = 500;
				c.blendMode = BlendMode.ERASE;
				s.blendMode = BlendMode.LAYER;
				addChildAt(s, 0);
				s.x = -200;
				s.y = -200;
				s.z = i * 200;
				s.cacheAsBitmap = true;
				tunnel.push(s);
			}
			Scheduler.invokeEvery(update);
			super();
		}
		
		public function update():void {
			var m:Point = new Point(Math.min(0, Math.max(mouseX - 600, -400)), Math.min(0, Math.max(mouseY - 500, -400)));
			var close:Boolean = Point.distance(new Point(tunnel[0].x,tunnel[0].y), oldPoint) > 10;
			
			for (var i:int = 0; i < tunnel.length; i++) {
				if (i == 0) {
					TweenLite.to(tunnel[i], 2, {x:m.x, y:m.y, ease: Cubic.easeOut } );
				}else {
					TweenLite.to(tunnel[i], 1, {x:tunnel[i-1].x, y:tunnel[i-1].y, ease:Cubic.easeOut } );
				}
				if (close){
					tunnel[i].z -= 10;
				}				
			}
			tunnel[0].alpha = (tunnel[0].z+600) / 200;
			if (tunnel[0].alpha < 0) {
				removeChild(tunnel[0]);
				tunnel[0] = null;
				tunnel.splice(0, 1);
				if (tunnel.length == 0) {
					Scheduler.cancel(update);
					endLevel();
					return;
				}
			}
			oldMouse.x = mouseX;
			oldMouse.y = mouseY;
			oldPoint.x = tunnel[0].x;
			oldPoint.y = tunnel[0].y;
		}
	}
	
}