package {
	import flash.display.Bitmap;
	import flash.display.Sprite;
	
	/**
	 * ...
	 * @author netgrind
	 */
	public class Title extends Level {
		
		[Embed(source = "../lib/title.png")]public var screen:Class
		
		public var outline:Sprite = new Sprite();
		public var fill:Sprite = UtilsArt.makeCircle(200,0xffffff)
		
		public function Title() {
			var s:Bitmap = new screen();
			s.blendMode = 'invert';
			addChild(s);
			outline.graphics.lineStyle(2, 0xff444444);
			outline.graphics.beginFill(0, 0);
			outline.graphics.drawCircle(0, 0, 100);
			outline.graphics.endFill();
			fill.scaleX = fill.scaleY = 0;
			outline.x = fill.x = 400;
			outline.y = fill.y = 470;
			addChild(outline);
			addChild(fill);
			super();
			Scheduler.invokeEvery(update);
		}
		
		public function update():void {
			if (outline.hitTestPoint(mouseX, mouseY, true)) {
				fill.scaleX = fill.scaleY +=.001;
				fill.scaleX = fill.scaleY *= 1.05;
				if (fill.scaleX > 3 ){
					endLevel();
					stage.color = 0xffffff;
					Scheduler.cancel(update);
				}
			}else if(fill.scaleX!=0){
				fill.scaleX = fill.scaleY /=1.1;
				if (fill.scaleX < 0) {
					fill.scaleX = fill.scaleY =0;
				}
			}
		}
		
	}
	
}