package {
	import flash.display.Sprite;
	import flash.events.Event;
	
	/**
	 * ...
	 * @author netgrind
	 */
	public class Main extends Sprite {
		
		public var levels:Array = [Title,DNA,Split,Birth,End];
		public var level:Level;
		
		public function Main():void {
			if (stage) init();
			else addEventListener(Event.ADDED_TO_STAGE, init);
		}
		
		private function init(e:Event = null):void {
			removeEventListener(Event.ADDED_TO_STAGE, init);
			// entry point
			
			Scheduler.init(stage);
			Key.init(stage);
			beginLevel();
		}
		
		public function beginLevel():void {
			level = new levels[0]();
			addChild(level);
			level.addEventListener(Level.DONE,endLevel)
		}
		
		public function endLevel(e:Event = null ):void {
			Utils.removeChild(level);
			level = null;
			levels.push(levels.shift());
			beginLevel();
		}
		
	}
	
}